
<?php
class Modules_AumInstaller_Install extends pm_LongTask_Task {
    public $trackProgress = true;

    function Init(string $user, string $pass, string $feedsource) {
        $this->setParam("Username", $user);
        $this->setParam("Password", $pass);
        $this->setParam("FeedSource", $feedsource);
    }

    public function run() {
		$i=0;
        pm_ApiCli::callSbin('download_installer.sh');
        for ($i=$i; $i <= 20; $i++) {
            $this->updateProgress($i);
            usleep(50000);
        }
        pm_ApiCli::callSbin('run_installer.sh',[(pm_Context::getVarDir())."plesk_aum_install.log"]);
        for ($i=$i; $i <= 40; $i++) {
            $this->updateProgress($i);
            usleep(50000);
        }

        $out="USERNAME=\"".$this->getParam("Username")."\"\n".
            "PASSWORD=\"".$this->getParam("Password")."\"\n".
            "FEED_SOURCE=\"".$this->getParam("FeedSource")."\"\n".
            "CONFIGURED=\"yes\"\n".
            "KERNEL_CHANNEL=\"disabled\"\n".
            "MODSEC_50_PLESK=\"".(($this->getParam("FeedSource")=="free-waf")?"yes":"no")."\"\n";

        file_put_contents((pm_Context::getVarDir())."awp.cfg",$out);
        file_put_contents((pm_Context::getVarDir())."asl.cfg",$out);
        for ($i=$i; $i <= 60; $i++) {
            $this->updateProgress($i);
            usleep(50000);
        }

        pm_ApiCli::callSbin('configure_aum.sh',[(pm_Context::getVarDir())."plesk_aum_install.log"]);
        for ($i=$i; $i < 100; $i++) {
            $this->updateProgress($i);
            usleep(50000);
        }
        $this->updateProgress(100);

    }

    public function statusMessage() {
        switch ($this->getStatus()) {
            case static::STATUS_RUNNING:
                return pm_Locale::lmsg("Installation in progress");
            case static::STATUS_DONE:
                return pm_Locale::lmsg("Done", ['id' => $this->getId()]);
            case static::STATUS_ERROR:
                return pm_Locale::lmsg("Error");
        }
        return '';
    }
}
?>
